Bug 471331 - Built-in Microphone doesn't work with Intel HDA audio
Built-in Microphone doesn't work with Intel HDA audio
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: alsa-lib (Show other bugs)
12
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jaroslav Kysela
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-12 19:24 EST by Andrig Miller
Modified: 2010-12-05 02:06 EST (History)
11 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-12-05 02:06:22 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Output from upstream alsa-info.sh, on my system, running up-to-date Fedora 11. (28.71 KB, text/plain)
2009-11-02 20:31 EST, Thomas Fitzsimmons
no flags Details
Output from upstream alsa-info.sh, on my system, running Ubuntu 9.10 Live image. (30.40 KB, text/plain)
2009-11-02 20:36 EST, Thomas Fitzsimmons
no flags Details
alsa-info for the lastest rawhide (updated from F12-Beta) with internal mic not working (25.93 KB, text/plain)
2009-11-03 04:01 EST, Ben Konrath
no flags Details
alsa-info for Ubuntu 9.10 live CD with internal mic working (27.35 KB, text/plain)
2009-11-03 04:03 EST, Ben Konrath
no flags Details
alsa-info.sh output (30.72 KB, application/octet-stream)
2009-11-10 16:10 EST, Andrig T Miller
no flags Details
alsa-info.sh output (29.87 KB, application/octet-stream)
2009-11-11 16:27 EST, Andrig T Miller
no flags Details
alsa-info.sh output (25.32 KB, text/plain)
2010-01-27 14:23 EST, Walter Tuvell
no flags Details
New alsa-info.sh output. (26.50 KB, text/plain)
2010-01-28 11:14 EST, Walter Tuvell
no flags Details

  None (edit)
Description Andrig Miller 2008-11-12 19:24:09 EST
Description of problem:

I have an HP dv7-1030us laptop, and it contains a built-in webcam and microphone.  Sound output works as expected, and I can record sound if I connect a microphone to the external jack, but cannot record audio through the built-in microphone (which shows up as Digital Mic 1 in the Alsa Mixer).

Version-Release number of selected component (if applicable):

1.0.18-6.rc3.fc10

How reproducible:

All the time.

Steps to Reproduce:
1. Set the input in the Alsa Mixer to Digital Mic 1
2. Try to record sound through the sound recorder, or optionally try to test out Skype.
3. 
  
Actual results:

Skype just fails to get your voice, and the test call fails, and the sound recorder application just hangs.

Expected results:

I should be able to record sound from the built-in mic, and be able to use Skype for voice and video using the internal mic, versus a headset.


Additional info:

I have determined that the built-in mic does indeed work.  I played around with creating an /etc/modprobe.d/sound file and putting the following line in it:

options snd_hda_intel model=5stack

With the above option, I can get something recorded off the built-in microphone, but the sound is crackled and barely recognizable, as well as the fact that the recording level is just pegged to 100%.  It doesn't fluctuate as you would expect with the volume of the sound being recorded.

In doing the research, there doesn't really appear to be a model option that matches the specific card I have in this laptop.

Here is the Codec information from codec#0, 1 in /proc/asound/card0

Codec: IDT 92HD71B7X
Codec: LSI ID 1040

and from codec#0 in /proc/asound/card1

Codec: ATI ATI RS690/780 HDMI

Also, I have attached the output of the latest alsa-info.sh.
Comment 1 Bug Zapper 2008-11-26 00:16:39 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Samuel Audet 2009-01-03 22:16:17 EST
I posted a workaround here 
https://bugzilla.redhat.com/show_bug.cgi?id=474477
Comment 3 Andrig Miller 2009-02-23 18:19:31 EST
Actually, this problem is really not the same as what they talk about in bugid 474477.

With a lot more research and experimentation, and a new Alsa version 1.0.19, I do have things working somewhat okay.

I don't have the low volume, and I don't have the crackling of the recorded audio, and here is what I had to do.

First, I created a /etc/modprobe.d/sound file, and in it I have the following (different from what I reported above):

options snd-hda-intel enable_msi=1 model=dell-m4-1

The model number of dell-m4-1, allows me to specify "Front Mic" for the microphone, versus "Mic", which appears to be correct, but the auto-configuration doesn't set that up correctly, although it appears to be reported from the dmesg output.

I still get a little of a high-pitched background noise when recording, but it works well enough.  I have can use Skype and the built-in microphone with no problems.

The only consistent problem I have now is that when I open the volume control, and turn on the capture1, capture2, and digital mic (all three have to be unmuted for the microphone to work), it will not stay unmuted unless I keep the volume control applet open all the time.  If I close it, it always gets muted, and whenever I shutdown and restart my laptop, or log off and login, I have to open the volume control, and unmute capture1, capture2, and digital mic, and leave the applet open.
Comment 4 Chris Shoemaker 2009-05-22 15:51:58 EDT
Is the remaining issue here a duplicate of Bug 483722  ?
Comment 5 Andrig Miller 2009-05-22 17:23:40 EDT
No, its not the same at all to that.

It's the capture settings that get muted, nothing to do with playback.
Comment 6 Chris Shoemaker 2009-06-09 12:53:38 EDT
The remaining issue sounds like it might be related to gnome-volume-control, or maybe pulseaudio is automatically "restoring" incorrect values as soon as you close the gnome-volume-control?  What version of gnome-volume-control do you have?  and if you're using pulseaudio, does the same thing happen if you
disable the module-*-restore modules in /etc/pulse/default.pa?
Comment 7 Andrig T Miller 2009-06-30 12:58:17 EDT
Actually, I have now upgraded to Fedora 11, so everything is different now.

In fact, I'm back to square one, which is I cannot record or use applications like Skype at all.

Playback works okay (volume is a little low), but no recording works anymore.  We may want to close this one, and start a new bug, unless others have reported the same issue already on Fedora 11.

I currently have an /etc/modprobe.d/sound file with the following:

options snd-hda-intel model=hp-m4

Version of alsa are as follows:

alsa-lib-1.0.20-1.fc11.x86_64

My alsa-info output is here:

http://www.alsa-project.org/db/?f=940ac6efc4d4eca6894bb8aa98c17f40600db353
Comment 8 Thomas Fitzsimmons 2009-11-02 20:31:41 EST
Created attachment 367242 [details]
Output from upstream alsa-info.sh, on my system, running up-to-date Fedora 11.
Comment 9 Thomas Fitzsimmons 2009-11-02 20:36:28 EST
Created attachment 367243 [details]
Output from upstream alsa-info.sh, on my system, running Ubuntu 9.10 Live image.

The built-in microphone receives input on Ubuntu 9.10.  I tested it using gnome-volume-control (the level bar is clearly responding to test sounds), and using GNOME Sound Recorder.

I've attached the output of the same alsa-info.sh script (downloaded from the upstream website) run on both Fedora 11 and Ubuntu 9.10.

I've also tested this on the Fedora 12 Beta Live image and the microphone input issue is not fixed.

Let me know if you need more data for comparison.  Could it be the extensive differences in the kernel module options that produce working results on Ubuntu?
Comment 10 Samuel Audet 2009-11-02 20:45:27 EST
No, it's probably because Ubuntu doesn't use PulseAudio (on input at least) by default...
Comment 11 Ben Konrath 2009-11-03 03:49:37 EST
(In reply to comment #10)
> No, it's probably because Ubuntu doesn't use PulseAudio (on input at least) by
> default...  

Actually Ubuntu 9.10 uses Pulse - you can see that in the log :-).
Comment 12 Ben Konrath 2009-11-03 04:01:01 EST
Created attachment 367272 [details]
alsa-info for the lastest rawhide (updated from F12-Beta) with internal mic not working

I'm having the same problem as Thomas in Comment #9 - the internal mic is working with rawhide updated from F12-Beta but it's working with Ubuntu 9.10. I'll attach the alsa-info out from Ubuntu in a few minutes.
Comment 13 Ben Konrath 2009-11-03 04:03:06 EST
Created attachment 367273 [details]
alsa-info for Ubuntu 9.10 live CD with internal mic working
Comment 14 Samuel Audet 2009-11-03 09:31:41 EST
Yes, PulseAudio is running, but ALSA is not using the pulse plug-in.. That's why it works. You would get the same effect in Fedora if you remove /etc/asound.conf from your system
Comment 15 Thomas Fitzsimmons 2009-11-03 21:20:05 EST
(In reply to comment #14)
> Yes, PulseAudio is running, but ALSA is not using the pulse plug-in.. That's
> why it works. You would get the same effect in Fedora if you remove
> /etc/asound.conf from your system

I just tried removing /etc/asound.conf. I don't get the same results as on Ubuntu at all.  gnome-volume-control's input level meter doesn't respond to test sounds, GNOME sound recorder records silence, and arecord > a.wav; aplay a.wav plays silence.

Jaroslav, are you following this bug?  Or should we assign it to someone else?
Comment 16 Samuel Audet 2009-11-04 20:33:13 EST
(In reply to comment #15)
> I just tried removing /etc/asound.conf. I don't get the same results as on
> Ubuntu at all.  gnome-volume-control's input level meter doesn't respond to

Duh, volume control in Fedora 11 also differs from the default one in Ubuntu:
https://fedoraproject.org/wiki/Volume_Control_in_Fedora_11

Try alsamixer :)
Comment 17 Thomas Fitzsimmons 2009-11-05 01:00:52 EST
(In reply to comment #16)

> Try alsamixer...

I did, as part of the arecord/aplay test.
Comment 18 Samuel Audet 2009-11-05 01:50:53 EST
(In reply to comment #17)
> > Try alsamixer...
> 
> I did, as part of the arecord/aplay test.  

Hum, maybe one more reason to stick to Fedora 10 on my laptop ...
Comment 19 Lennart Poettering 2009-11-05 14:04:10 EST
Please try the following:

$ alsactl init 0

then, please try to record something from the mike, bypassing PA:

$ arecord -D front:0 -f CD | strings

and check if that works, i.e. if when you tap your mike you see some random'ish strings generated on the terminal, or otherwise see feedback on the terminal for noises you make.

If that doesn't help, please run "alsamixer -c0" and try to play around with any mixer controls you find that might be related to this, and try the above line again. Try different things, always verifying if this did help anything. 

Finally, if all this still didn't yield any results, play around with the snd-hda-intel options, i.e. model= and msi_enable= (don't forget to reload those modules!) and see if that changes anything. If that still didn't help this needs some fixing in the driver and I cannot help you any further, only Jaroslav can.

If you manage to track this down, please report back what exactly helped so that we can update the default mixer database accordingly or add your model to the quirk table inside of the driver.
Comment 20 Thomas Fitzsimmons 2009-11-05 14:35:09 EST
$ alsactl init 0
Unknown hardware: "HDA-Intel" "Intel G45 DEVCTG" "HDA:111d76b2,103c3602,00100302 HDA:80862802,80860101,00100000" "0x103c" "0x3602"
Hardware is initialized using a guess method

OK, I had played around with alsamixer (without issuing alsactl init 0 first) but I had been focusing on the Capture tab.  The arecord command you posted produces output when, in the Playback tab, I select "Digital Mic 1" for both the "Digital Input Source" columns.  In the Capture tab, I also selected "Front Mic" for both the "Input Source" and "Input Source 1" columns.

Now the mic works, in gnome-volume-control and GNOME sound recorder.  OK, now let me re-initialize and narrow down the smallest number of changes required to the initial state to make the mic work.
Comment 21 Thomas Fitzsimmons 2009-11-05 14:58:43 EST
I've narrowed the settings down further.  I need to confirm these changes after a reboot, but the current list is:

"Playback" -> "Digital Input Source"
  defaults to: "Analog Inputs"
  needs to be: "Digital Mic 1"

"Playback" -> "Digital Input Source"
  defaults to: "Analog Inputs"
  needs to be: "Digital Mic 1"

I'm not sure why there are two "Digital Input Source" columns in the "Playback" tab, but I'm setting them both to the same value.  In any case, I wouldn't know how to distinguish between them if one and not the other mattered for mic support.

I also need to make sure the "Capture" -> "Capture" is set to non-zero, but I expect gnome-volume-control should take care of this.
Comment 22 Thomas Fitzsimmons 2009-11-05 18:37:59 EST
These settings seem to persist across reboot so I can't compare them to the "default" values.  Can you advise me how to compare these values to the model values ALSA has in its database?  To the others CCd on this bug with the same laptop model, can you please try the workaround in Comment #21 and report back?

Also, why would Ubuntu get this right and Fedora get it wrong?  Isn't the upstream model database shared?

(I'm still getting the occasional pop on the built-in speakers, but that can be handled as a separate bug report).

Jaroslav, can you update the F12 alsa-lib database to include this workaround?
Comment 23 Andrig T Miller 2009-11-05 19:44:33 EST
I've tried to change the settings in all kinds of ways, and yet I still cannot record anything off the built-in mic.

In between a couple of kernel versions, I could actually successfully record when I would plug in my headset, but even that doesn't work anymore.

I'm still on the same laptop that I was on when I first opened this, and at one time it actually worked, when I used model=dell-m4-1, but that doesn't work either.

I know set model=hp-m4 in /etc/modprobe.d/sound.conf.

If I remove the sound.conf all together, no luck.  If I remove asound.conf from /etc, no luck.  No changes in any settings seem to work at all.

This has been so flaky.
Comment 24 Ben Konrath 2009-11-05 20:10:51 EST
I made the same changes as Thomas in comment #21 and the built in mic is now working. Here's the output from 'alsactl init 0' in case it's useful:

Unknown hardware: "HDA-Intel" "Intel G45 DEVCTG" "HDA:111d76b2,103c30f7,00100302 HDA:11c11040,103c137e,00100200 HDA:80862802,80860101,00100000" "0x103c" "0x30f7"
Hardware is initialized using a guess method
Comment 25 Andrig T Miller 2009-11-05 20:22:27 EST
I have different hardware:

 alsactl init 0
Unknown hardware: "HDA-Intel" "IDT 92HD71B7X" "HDA:111d76b2,103c30fc,00100302 HDA:11c11040,103c137e,00100200" "0x103c" "0x30fc"
Hardware is initialized using a guess method
Comment 26 Ben Konrath 2009-11-10 14:25:21 EST
(In reply to comment #19)
> If you manage to track this down, please report back what exactly helped so
> that we can update the default mixer database accordingly or add your model to
> the quirk table inside of the driver.  

Lennart, Did you update the mixer database with the results from our sound cards?

Thomas:

Unknown hardware: "HDA-Intel" "Intel G45 DEVCTG"
"HDA:111d76b2,103c3602,00100302 HDA:80862802,80860101,00100000" "0x103c"
"0x3602"
Hardware is initialized using a guess method

Mine:

Unknown hardware: "HDA-Intel" "Intel G45 DEVCTG"
"HDA:111d76b2,103c30f7,00100302 HDA:11c11040,103c137e,00100200
HDA:80862802,80860101,00100000" "0x103c" "0x30f7"
Hardware is initialized using a guess method

We both had to make the following changes:

"Playback" -> "Digital Input Source"
  defaults to: "Analog Inputs"
  needs to be: "Digital Mic 1"

"Playback" -> "Digital Input Source"
  defaults to: "Analog Inputs"
  needs to be: "Digital Mic 1"

Thanks, Ben
Comment 27 Andrig T Miller 2009-11-10 15:02:12 EST
While I'm glad some progress seems to have been made with hardware other than mine, the workaround doesn't work for my hardware, which is different, and if someone else has my same hardware to test with that would be great.

I have tried some new things, such as using two different models, which are new in the documentation for the kernel (I hadn't seen these before).

model=hp-dv5
model=hp-hdx

Neither of those models, along with changing the mixer settings worked either.

Again, my alsa init 0 command spits out the following:

Unknown hardware: "HDA-Intel" "IDT 92HD71B7X" "HDA:111d76b2,103c30fc,00100302
HDA:11c11040,103c137e,00100200" "0x103c" "0x30fc"
Hardware is initialized using a guess method
Comment 28 Thomas Fitzsimmons 2009-11-10 15:54:35 EST
Andrig, can you post the output of alsa-info.sh --no-upload?  It's interesting that alsa-info.sh shows the exact same codec for my hardware (IDT 92HD71B7X), but in other places refers to "Intel G45 DEVCTG".
Comment 29 Andrig T Miller 2009-11-10 16:10:14 EST
Created attachment 368845 [details]
alsa-info.sh output

Sure thing.  See the attachment.
Comment 30 Thomas Fitzsimmons 2009-11-10 16:50:54 EST
I can't see anything obvious from diffing our alsa-info.sh outputs.  Have you tried an Ubuntu Live image?  If that worked, it would at least give you a basis for comparison.
Comment 31 Andrig T Miller 2009-11-10 17:02:12 EST
I haven't tried that, but I certainly could give it a try.  Yes, that would be quite interesting since people on the report have stated that it seems to work in Ubuntu.  I'll download an image and burn it, and give it a try.
Comment 32 Lennart Poettering 2009-11-10 17:10:41 EST
(In reply to comment #26)
> (In reply to comment #19)
> > If you manage to track this down, please report back what exactly helped so
> > that we can update the default mixer database accordingly or add your model to
> > the quirk table inside of the driver.  
> 
> Lennart, Did you update the mixer database with the results from our sound
> cards?

No I haven't. That's something I better leave for Jaroslav, the ALSA maintainer both upstream and downstream
Comment 33 Andrig T Miller 2009-11-10 20:07:09 EST
(In reply to comment #30)
> I can't see anything obvious from diffing our alsa-info.sh outputs.  Have you
> tried an Ubuntu Live image?  If that worked, it would at least give you a basis
> for comparison.  

I booted up Ubuntu 9.10 on my system from the Live DVD I burned, and tried out recording sound.  What' interesting is it didn't work at first, but then I went into System->Preferences->Sound and looked at the Input tab.  It was muted.  When I unmuted on that tab, I immediately received a meter that fluctuated with any sound I made.

I then went back to the sound recorder and was able to record sound without any problems.  So, it definitely works on Ubuntu 9.10, with only the one change to unmute the input.  By the way, it is the X86_64 version.
Comment 34 Ben Konrath 2009-11-11 12:52:02 EST
Andrig, 

You should try running 'alsa-info --no-upload' on the Ubuntu system and the Fedora system and then compare the results. You could also post the results here so that other people can have a look.

I don't think Ubuntu packages the alsa-info.sh script so you'll have to download it:

www.alsa-project.org/alsa-info.sh

It's probably a good idea to run the same downloaded version on both systems.
Comment 35 Andrig T Miller 2009-11-11 16:27:42 EST
Created attachment 369110 [details]
alsa-info.sh output

Okay, I manage to have the time to reboot using the Ubuntu 9.10 live DVD, and run the downloaded alsa-info.sh script off my USB key.

So, the results are attached.  The thing I find interesting, is that don't pass and model information to the driver, they are using 1.0.20 version of the Driver, the Library and the Utilities.  In my Fedora output I attached, we have 1.0.20 of the Driver the Library version is blank for some reason, and the Utilities is 1.0.21.  They have the 2.6.31 kernel, instead of 2.6.30, and besides have more sound related modules that load, they do pass some power saving options to the snd_hda_intel driver.

The alsa device nodes are different in that they have a /dev/snd/seq node that isn't in Fedora.

The mixer controls are slightly different as well.

Another interesting side note, is that in the sound preferences applet, on the Hardware tab, Ubuntu has Analog Stereo Duplex as the option configured, and that option doesn't exist in Fedora.

So, things are close, but the addition kernel modules it loads (don't know why), and the missing library version, and the different utilities versions seem to be the big differences.

You might find more things that are different, as I didn't strictly compare everything.
Comment 36 Jaroslav Kysela 2009-11-12 04:09:07 EST
(In reply to comment #35)
> They have the 2.6.31 kernel, instead of 2.6.30.

OK. Appearently the recent ALSA drivers solves this problem for you. You may compile the latest ALSA driver also for Fedora kernel - see http://www.alsa-project.org or wait until Fedora kernel gets updated to 2.6.31.
Comment 37 Jaroslav Kysela 2009-11-12 04:11:49 EST
(In reply to comment #21)
> I've narrowed the settings down further.  I need to confirm these changes after
> a reboot, but the current list is:
> 
> "Playback" -> "Digital Input Source"
>   defaults to: "Analog Inputs"
>   needs to be: "Digital Mic 1"

I added initialization for first Digital Input Source as "Digital Mic 1" to the ALSA tree. The change will be in next alsa-utils package release for Fedora.
Comment 38 Andrig T Miller 2009-11-12 11:20:55 EST
(In reply to comment #36)
> (In reply to comment #35)
> > They have the 2.6.31 kernel, instead of 2.6.30.
> 
> OK. Appearently the recent ALSA drivers solves this problem for you. You may
> compile the latest ALSA driver also for Fedora kernel - see
> http://www.alsa-project.org or wait until Fedora kernel gets updated to 2.6.31.  

I'm not so sure, since the driver version in the alsa-info.sh output seems to be the same regardless that they have the 2.6.31 kernel.

They are both 1.0.20.

In any case, I will probably upgrade to Fedora 12, since its only 5 days away, and maybe that will work.
Comment 39 Bug Zapper 2009-11-16 04:36:05 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 40 Andrig T Miller 2009-11-18 13:05:38 EST
Okay, I have successfully upgraded to Fedora 12, and tested out recording off the built-in microphone on my laptop.  I had to use the advanced volume control application to change the default to "Digital Mic 1".

Once I did that I was successfully recording audio using Skype (test call), and Cheese.

I did have to up the amplification quite a bit in the sound preferences, and there is a background his or hum, but its not too bad.  Generally it is working, which is great!
Comment 41 Thomas Fitzsimmons 2009-11-19 20:33:30 EST
(In reply to comment #37)
> (In reply to comment #21)
> > I've narrowed the settings down further.  I need to confirm these changes after
> > a reboot, but the current list is:
> > 
> > "Playback" -> "Digital Input Source"
> >   defaults to: "Analog Inputs"
> >   needs to be: "Digital Mic 1"
> 
> I added initialization for first Digital Input Source as "Digital Mic 1" to the
> ALSA tree. The change will be in next alsa-utils package release for Fedora.  

Jaroslav, did this change make it into Fedora 12?  If so I think we can close this bug.
Comment 42 Andrig T Miller 2009-11-20 00:09:41 EST
(In reply to comment #41)
> (In reply to comment #37)
> > (In reply to comment #21)
> > > I've narrowed the settings down further.  I need to confirm these changes after
> > > a reboot, but the current list is:
> > > 
> > > "Playback" -> "Digital Input Source"
> > >   defaults to: "Analog Inputs"
> > >   needs to be: "Digital Mic 1"
> > 
> > I added initialization for first Digital Input Source as "Digital Mic 1" to the
> > ALSA tree. The change will be in next alsa-utils package release for Fedora.  
> 
> Jaroslav, did this change make it into Fedora 12?  If so I think we can close
> this bug.  

I didn't based on my upgrade.  I had to change the default to Digital Mic 1 in the advanced sound preferences.
Comment 43 Andrig T Miller 2009-12-01 11:23:01 EST
One additional comment.  When I applied today's updates to Fedora 12, recording off the microphone didn't work initially.  I had to go into the sound preferences, and change the input to Microphone/Microphone from Microphone/Input.  Then everything started working as before.  So, maybe there is not two defaults that have to be adjusted, the first being "Digital Mic 1", and the second being the Microphone/Microphone setting.
Comment 44 Brad 2010-01-07 13:46:33 EST
Also on fedora 12, on a fujitsu P7120 the internal microphone is not working.

[root@localhost ~]# alsactl init 0
Unknown hardware: "HDA-Intel" "Realtek ALC260" "HDA:10ec0260,10cf0000,00100400 HDA:11c13026,11c13026,00100600" "0x10cf" "0x1326"
Hardware is initialized using a guess method

Tested for internal mic operation using arecord (as above) and skype, to no avail.  Changes to alsamixer playback and capture settings did not seem to make a difference.

Should I be using a model= driver argument?  I can't find any reference to that.
Comment 45 Walter Tuvell 2010-01-27 14:21:16 EST
I'm seeing this problem too.  I've read through this Bugzilla, but there seem to be mixed signals in it (things seem to be working for some people, under some circumstances, some of the time), and I was wondering if anybody can summarize the current status of this problem?

Here's some more info about my situation (see also the attached alsa-info.txt):

I'm running up-to-date Fedora 12 on a Sony Vaio laptop.  Everything works except the internal microphone.

When I run "alsact init 0", I get:

Unknown hardware: "HDA-Intel" "Intel G45 DEVCTG" "HDA:10ec0262,104d3a00,00100302 HDA:80862802,80860101,00100000" "0x104d" "0x9056"
Hardware is initialized using a guess method

When I run alsamixer, it verifies it's seeing "Card: HDA Intel" and "Chip: Intel G45 DEVCTG".  I use the F6 command to select sound card "0 HDA Intel", then the F5 command to show 12 controls.  These have the following values, which can vary slightly from instance to instance, but are never insanely variable (can anybody spot a wrong setting here?):

    Master       53<>53    00(=unmuted, as opposed to M=muted)
    PCM          99<>99
    Mic          77<>77    00
    S/PDIF                 00
    Beep         55<>55    00
    Capture      74<>74    CAPTURE(=unmuted, as opposed to -------=muted)
    Capture 1    68<>68    CAPTURE
    Capture 2    68<>68    CAPTURE
    ATAPI Mic    68<>68    00
    Input Sou    Mic (other choices are Line, CD, Front Mic)
    Input Sou    Mic
    Input Sou    Mic

When I run gnome-volume-control (System --> Preferences --> Sound) and look at the Input tab, the Input volume is unmuted and half-way amplified, and 3 Connectors are listed (Line In, Microphone 1, Microphone 2).

No matter how I twiddle the above settings, I can't get the internal mic to work (e.g., to budge the Input Level meter in gnome-volume-control, or to get a successful Skype Echo123, or Lennart's arecord test).  To get the external mic to work, I must use Input Sou = Mic, Connector = Microphone 1 (i.e., they map to one another).

FWIW, the internal mic doesn't work for me under the Ubuntu 9.10 Live CD either.

About the only thing I didn't try was to "play around with the snd-hda-intel options", because I don't really have a good idea what's up with that.  Is there some documentation for how to do that?  (I gather Brad is asking for similar documentation.)
Comment 46 Walter Tuvell 2010-01-27 14:23:36 EST
Created attachment 387158 [details]
alsa-info.sh output

My alsa-info.sh output.
Comment 47 Walter Tuvell 2010-01-28 11:13:04 EST
NEVER MIND!  I've got my internal mic working now.

What I did was check http://alsa-project.org/main/index.php/Download, and noticed there was a newer version of alsa-driver (1.0.22.1).  After downloading, building and installing it, my HDA now seems to work flawlessly.

For the record, I'll re-run alsa-info.sh and attach it here.
Comment 48 Walter Tuvell 2010-01-28 11:14:35 EST
Created attachment 387368 [details]
New alsa-info.sh output.

My new also-info.sh output.
Comment 49 Brad 2010-02-08 18:46:26 EST
Workaround:

I am using FC12 and its included alsa driver (1.0.22) on my Fujitsu P7120.  I can use Skype with the built-in mic and headphones by using:

In /etc/modprobe.d/alsa-base.conf:

options snd-hda-intel model=test

Then before running skype:

% amixer --stdin << EOF
sset LOUT2 0% mute
sset LOUT1 60% unmute
sset MIC2 60% unmute cap
sset 'Input Source' 'MIC2 pin'
sset 'MIC2 pin mode' 'Mic 80pc bias'
EOF

That seems to effectively mute the onboard speakers (LOUT2), unmute the headphones (LOUT1), and unmute/capture the onboard mic (MIC2).

I don't know how to tell alsa to use this configuration "by default", and I don't know how to have alsa automatically mute the speakers and unmute the headphones when I plug headphones in, and do the reverse when I unplug them.  I bet it's possible (via .asoundrc?), and I'm just ignirrint.  

I'm not sure which pin complex the Mic jack is connected to on the P7120 (I suspect MIC1).
Comment 50 Bug Zapper 2010-11-04 07:42:15 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 51 Bug Zapper 2010-12-05 02:06:22 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.